;Blur Libary by Jan Kuhnert
;Diese Blur effekt Libary fr Blitz Basic 3D wurde von Jan Kuhnert entwickelt.

Global Blur_image_primaer, blur_texture, blur_gw, blur_gh,Blur_W,Blur_H,Blur_R,Blur_g,Blur_B
Global Blur_image_secundaer,Blur_image_tri,Blur_Wett#,Blur_TX,Blur_TY,Blur_surface,Blur_def
Global Blur_Time,Blur_Timeset,blur_ibloom,blur_bloom_qual,blur_bloom_rad

Dim Blur_Point(10,10)
Dim Blur_bloom(6,3)

Function CreateBlur(BlurCam,CameraEntfernung# = 4,Weichen# = 0,r=255,g=255,b=255,Zoomeffekt# = 0.0,Blend = False,X_Teilung=1,Y_Teilung=1)
	Local sf,spr,w#,h#,BildschirmVerhaeltnis#
	Local ScaleX#,ScaleY#

	Dim Blur_Point(X_Teilung,Y_Teilung)
	
	Blur_TX=X_Teilung
	Blur_TY=Y_Teilung
	
	Blur_Cam = BlurCam
	
	Blur_r=r
	Blur_g=g
	Blur_b=b
	
	If blurimage <> 0 Then
	  FreeBlur()
	EndIf
	blur_gw = GraphicsWidth()
	Blur_gh = GraphicsHeight()
	
	blur_texture = CreateTexture(blur_gw, blur_gh, 1+256)
	Blur_W=TextureWidth(blur_texture)
	Blur_H=TextureHeight(blur_texture)

	w#=Blur_W - blur_gw
	h#=Blur_h - blur_gh
	
	BildschirmVerhaeltnis#= Float(blur_gh)/Float(blur_gw)*cameraEntfernung#

	ScaleX# = cameraEntfernung# + (cameraEntfernung#*w#/Float(blur_gw))
	ScaleY# = BildschirmVerhaeltnis#+ (BildschirmVerhaeltnis#*h#/Float(blur_gh))

	BB_to_Pixel_X# =  (ScaleX#/Blur_W)
	BB_to_Pixel_Y# =  (ScaleY#/Blur_H)

	Local Schnitt_X#,Schnitt_Y#
	Schnitt_X#=((1.0/Blur_W)*W#)/2.0
	Schnitt_Y#=((1.0/Blur_H)*H#)/2.0

	spr = CreateMesh(BlurCam)
	sf = CreateSurface(spr)

	Local X,Y
	Local X2#,Y2#
	X2#=X_Teilung/2.0
	Y2#=Y_Teilung/2.0
	
	For x = 0 To X_Teilung
		For y = 0 To Y_Teilung
			Blur_Point(X,Y) = AddVertex(sf,(X-X2#)/X2#,(y-Y2#)/Y2#,0,(x/Float(X_Teilung))-(Schnitt_X#*((X-X2#)/X2#)),(-y/Float(Y_Teilung))+(Schnitt_Y#*(y-Y2#)/Y2#))
		Next
	Next
	For x = 1 To X_Teilung
		For y = 1 To Y_Teilung
			AddTriangle sf,Blur_Point(X,Y),Blur_Point(X,Y-1),Blur_Point(X-1,Y)
			AddTriangle sf,Blur_Point(X,Y-1),Blur_Point(X-1,Y-1),Blur_Point(X-1,Y)
		Next
	Next

 	EntityFX spr, 1+8+32

	EntityOrder spr, -(2^30)
	EntityBlend spr, 1
	EntityAlpha spr,0
	
	
	ScaleEntity spr,1.0*CameraEntfernung#,0.75*CameraEntfernung#,1.0	

	PositionEntity spr,-BB_to_Pixel_X#,BB_to_Pixel_Y#,CameraEntfernung#
	
	Blur_W=(w#/2.0)
	Blur_h=(h#/2.0)
	
	EntityTexture spr, blur_texture
	If Blend Then EntityBlend spr, 3
	Blur_image_primaer = spr
	Blur_surface = sf
	
	If Weichen# <>0
		Blur_image_secundaer = CopyEntity(spr,Blurcam)
		Blur_image_tri = CopyEntity(spr,Blurcam)

		Blur_wett#=Weichen#
		
		PositionEntity blur_image_primaer,-BB_to_Pixel_X#+((sin#(0)*BB_to_Pixel_X#)*Weichen#/2.0),BB_to_Pixel_y#+(cos#(0)*BB_to_Pixel_y#*Weichen#)/2.0,CameraEntfernung#,0
		
		PositionEntity Blur_image_secundaer,-BB_to_Pixel_X#+((sin#(120)*BB_to_Pixel_X#)*Weichen#/2.0),BB_to_Pixel_y#+(cos#(120)*BB_to_Pixel_y#*Weichen#)/2.0,CameraEntfernung#,0

		PositionEntity Blur_image_tri,-BB_to_Pixel_X#+((Sin#(240)*BB_to_Pixel_X#)*Weichen#/2.0),BB_to_Pixel_y#+(Cos#(240)*BB_to_Pixel_y#*Weichen#)/2.0,CameraEntfernung#,0
		
		If Blend Then EntityBlend Blur_image_secundaer, 3
		If Blend Then EntityBlend Blur_image_tri, 3
 	EndIf
 	


End Function

Function CreateBloom(BlurCam,CameraEntfernung# = 4, Bloom#=1.0,r=255,g=255,b=255, Bloomquality=6, Bloomsides=3)
	Local sf,spr,w#,h#,BildschirmVerhaeltnis#
	Local ScaleX#,ScaleY#

	Local X_Teilung=1,Y_Teilung=1

	blur_bloom_qual=Bloomquality
	blur_bloom_rad=Bloomsides

	Dim Blur_Point(1,1)
	Dim blur_bloom(Bloomquality-1,Bloomsides-1)

	Blur_Cam = BlurCam
	
	Blur_r=r
	Blur_g=g
	Blur_b=b
	
	If blurimage <> 0 Then
	  FreeBlur()
	EndIf
	
	blur_ibloom=1
	
	blur_gw = GraphicsWidth()
	Blur_gh = GraphicsHeight()
	
	blur_texture = CreateTexture(blur_gw, blur_gh, 1+256)
	Blur_W=TextureWidth(blur_texture)
	Blur_H=TextureHeight(blur_texture)

	w#=Blur_W - blur_gw
	h#=Blur_h - blur_gh
	
	BildschirmVerhaeltnis#= Float(blur_gh)/Float(blur_gw)*cameraEntfernung#

	ScaleX# = cameraEntfernung# + (cameraEntfernung#*w#/Float(blur_gw))
	ScaleY# = BildschirmVerhaeltnis#+ (BildschirmVerhaeltnis#*h#/Float(blur_gh))

	BB_to_Pixel_X# =  (ScaleX#/Blur_W)
	BB_to_Pixel_Y# =  (ScaleY#/Blur_H)

	Local Schnitt_X#,Schnitt_Y#
	Schnitt_X#=((1.0/Blur_W)*W#)/2.0
	Schnitt_Y#=((1.0/Blur_H)*H#)/2.0

	spr = CreateMesh(BlurCam)
	sf = CreateSurface(spr)

	Local X,Y
	Local X2#,Y2#
	X2#=X_Teilung/2.0
	Y2#=Y_Teilung/2.0
	
	For x = 0 To X_Teilung
		For y = 0 To Y_Teilung
			Blur_Point(X,Y) = AddVertex(sf,(X-X2#)/X2#,(y-Y2#)/Y2#,0,(x/Float(X_Teilung))-(Schnitt_X#*((X-X2#)/X2#)),(-y/Float(Y_Teilung))+(Schnitt_Y#*(y-Y2#)/Y2#))
		Next
	Next
	For x = 1 To X_Teilung
		For y = 1 To Y_Teilung
			AddTriangle sf,Blur_Point(X,Y),Blur_Point(X,Y-1),Blur_Point(X-1,Y)
			AddTriangle sf,Blur_Point(X,Y-1),Blur_Point(X-1,Y-1),Blur_Point(X-1,Y)
		Next
	Next

 	EntityFX spr, 1+8+32

	EntityOrder spr, -(2^30)
	EntityBlend spr, 1
	EntityAlpha spr,0
;	If Blend EntityBlend spr, 3
	
	ScaleEntity spr,1.0*CameraEntfernung#,0.75*CameraEntfernung#,1.0	

	PositionEntity spr,-BB_to_Pixel_X#,BB_to_Pixel_Y#,CameraEntfernung#
	
	Blur_W=(w#/2.0)
	Blur_h=(h#/2.0)
	
	EntityTexture spr, blur_texture
	
	Blur_image_primaer = spr
;	EntityBlend spr, 3
	Blur_surface = sf
	;Stop
;	If Weichen# <>0
		;Blur_image_secundaer = CopyEntity(spr,Blurcam)
		;Blur_image_tri = CopyEntity(spr,Blurcam)

		;Blur_wett#=Weichen#
		
		Local o,u
		For u = 1 To Bloomquality
			For o = 1 To Bloomsides
				Local grad# = Float(360.0/Bloomsides)*Float(o)
				blur_bloom(u-1,o-1)=CopyEntity(spr,Blurcam)
				EntityBlend blur_bloom(u-1,o-1), 3
				
				PositionEntity blur_bloom(u-1,o-1),-BB_to_Pixel_X#+(Sin#(grad)*Bloom#/Float(bloomquality)*u),BB_to_Pixel_y#+(Cos#(grad)*Bloom#/Float(bloomquality)*u),CameraEntfernung#,0

			Next
		Next
; 	EndIf
 	


End Function

Function SetBlurUpdateTime(time)
	Blur_Timeset = time
End function

Function SetBlurDeform(X,Y,MoveX#,MoveY#)
	Local Real_X,Real_Y
	Local VX#,VY#,VZ#
	Local REd,Green,Blue

	Real_X=Blur_TX/Float(Blur_gw)*Float(X)
	Real_Y=Blur_TY/Float(Blur_gh)*Float(Y)
	VX#=(Real_X-(Blur_TX/2.0))/float(Blur_TX/2.0) +(MoveX#/float(Blur_TX))
	VY#=(Real_Y-(Blur_TY/2.0))/float(Blur_TY/2.0) +(MoveY#/float(Blur_TY))
	VZ#=VertexZ#(Blur_surface,Blur_Point(Real_X,Real_Y))
	VertexCoords Blur_surface,Blur_Point(Real_X,Real_Y),VX#,VY#,VZ#
	Red=VERTEXRED(Blur_surface, Blur_Point(Real_X,Real_Y))
	Green=VERTEXGREEN(Blur_surface, Blur_Point(Real_X,Real_Y))
	Blue=VERTEXBLUE(Blur_surface, Blur_Point(Real_X,Real_Y))
	VertexColor Blur_surface, Blur_Point(Real_X,Real_Y), Red, Green, Blue ,1

End Function

Function InitDeform()
	Local Real_X,Real_Y
	Local VX#,VY#,VZ#
	Local REd,Green,Blue

	For Real_X=0 To Blur_TX
	  For Real_Y=0 To Blur_TY
			VX#=(Real_X-(Blur_TX/2.0))/float(Blur_TX/2.0)
			VY#=(Real_Y-(Blur_TY/2.0))/float(Blur_TY/2.0)
			VZ#=VertexZ#(Blur_surface,Blur_Point(Real_X,Real_Y))
			VertexCoords Blur_surface,Blur_Point(Real_X,Real_Y),VX#,VY#,VZ#
			Red=VERTEXRED(Blur_surface, Blur_Point(Real_X,Real_Y))
			Green=VERTEXGREEN(Blur_surface, Blur_Point(Real_X,Real_Y))
			Blue=VERTEXBLUE(Blur_surface, Blur_Point(Real_X,Real_Y))
			VertexColor Blur_surface, Blur_Point(Real_X,Real_Y), Red, Green, Blue ,0
		next
	Next
	Blur_def=1

End function

Function UpdateBlur(power#)
	Local Time
	If power# >0.99 Then power# = 0.99

	If Blur_Wett# <>0
		If power# >0.48 Then power# = 0.48
		EntityAlpha Blur_image_secundaer, power#
		EntityColor Blur_image_secundaer,Blur_R,Blur_g,Blur_b
		EntityAlpha Blur_image_tri, power#
		EntityColor Blur_image_tri,Blur_R,Blur_g,Blur_b
	EndIf
	If blur_ibloom
		Local i,g
		For i=0 To blur_bloom_qual-1
			For g=0 To blur_bloom_rad-1
				EntityAlpha blur_bloom(i,g), power#/Float(blur_bloom_qual*blur_bloom_rad)
				EntityColor blur_bloom(i,g),Blur_R,Blur_g,Blur_b
			Next
		Next 
	EndIf
	EntityAlpha Blur_image_primaer, power#
	EntityColor Blur_image_primaer,Blur_R,Blur_g,Blur_b
	time = MilliSecs()
	If Blur_Time < time-Blur_Timeset
		Blur_Time = time
		CopyRect  0, 0, Blur_GW, Blur_gh, Blur_W, Blur_h, BackBuffer(), TextureBuffer(blur_texture)
	EndIf
End Function

Function SetBlurColor(R,G,B)
	If r > 255 Then r= 255
	If g > 255 Then g= 255
	If b > 255 Then b= 255
	If r < 0 Then r= 0
	If g < 0 Then g= 0
	If b < 0 Then b= 0
	Blur_R=R:Blur_g=G:Blur_b=B
End Function

Function SetBlurParent(Parent)
	Local X#,Y#,Z#
	X#=EntityX#(Blur_image_primaer,0)
	Y#=EntityY#(Blur_image_primaer,0)
	Z#=EntityZ#(Blur_image_primaer,0)
	EntityParent Blur_image_primaer,Parent
	PositionEntity Blur_image_primaer,X#,Y#,Z#,False
	If Blur_Wett# <>0
		X#=EntityX#(Blur_image_secundaer,0)
		Y#=EntityY#(Blur_image_secundaer,0)
		Z#=EntityZ#(Blur_image_secundaer,0)
		EntityParent Blur_image_secundaer,Parent
		PositionEntity Blur_image_secundaer,X#,Y#,Z#,False
		
		X#=EntityX#(Blur_image_tri,0)
		Y#=EntityY#(Blur_image_tri,0)
		Z#=EntityZ#(Blur_image_tri,0)
		EntityParent Blur_image_tri,Parent
		PositionEntity Blur_image_tri,X#,Y#,Z#,False
	EndIf
End function

Function FreeBlur()
	FreeEntity Blur_image_primaer
	If Blur_Wett# <>0
		FreeEntity Blur_image_secundaer
		FreeEntity Blur_image_tri
		Blur_image_secundaer=0
		Blur_image_tri=0
	EndIf
	If blur_ibloom
		Local i,g
		For i=0 To blur_bloom_qual-1
			For g=0 To blur_bloom_rad-1
				FreeEntity blur_bloom(i,g)
			Next
		Next 
	EndIf
	blur_ibloom=0
	blur_def=0
	FreeTexture blur_texture
	Blur_image_primaer=0
	Blur_texture=0
	Blur_Wett=0
End Function

