;BSP For the Blur Lib from Jan Kuhnert
;www.FX-visions.de

;{
;Including
	Include "blur.bb"
	Include "FPS.bb"
	Include "Skybox\Loadskybox.bb"
;}
	
;{
;Graphics initializing
	Graphics3D 800,600,32,2
	SetBuffer BackBuffer()
;}

;{
;Create Scene
	Cam=CreateCamera()
	CameraRange cam,0.1,1000
	PositionEntity cam,5,5,7

	skybox=Loadskybox("Skybox\Sky",cam)
	mesh=LoadMesh("example.b3d")
;}

Dim Name$(4)
Name$(0)="Bloom"
Name$(1)="MotionBlur"
Name$(2)="Blend MotionBlur"
Name$(3)="AntiAlias"
Name$(4)="Black hohle"

.start
;{
;CreateBlur effekts

	If m= 0 CreateBloom(Cam,4.0, 1.5,55,55,55,6,3) ; Bloom sehr genau und aufwendig
	If m= 1 CreateBlur(Cam);Perfektes MotionBlur, ohne verschwimmen
	If m= 2 CreateBlur(Cam,4,0,0,255,255,16,3);Bildschirm Blenden
	SetBlurUpdateTime(0)

	If m= 3 CreateBlur(Cam,4,0.9):SetBlurUpdateTime(0);Bildschirm Weichen


	If m=4
	CreateBlur(Cam,4,0,0,255,255,255,0,24,24);Deform Bildschirm
	InitDeform()
		For X = -90 To 90
		  For Y= -90 To 90
			SetBlurDeform(GraphicsWidth()/2+X,GraphicsHeight()/2+Y,-x/100.0,-y/100.0)
		  Next
		Next
		SetBlurUpdateTime(0)
	EndIf

	If m= 5 Then End
	m=m+1
;}
	rm=255
	Repeat

		RotateEntity skybox,0,0,0,1

		If KeyDown(200) Then TurnEntity cam,1,0,0
		If KeyDown(208) Then TurnEntity cam,-1,0,0
		If KeyDown(203) Then TurnEntity cam,0,1,0
		If KeyDown(205) Then TurnEntity cam,0,-1,0
		If KeyHit(2) Then blur# = 0.0
		If KeyHit(3) Then blur# = 0.15
		If KeyHit(4) Then blur# = 0.3
		If KeyHit(5) Then blur# = 0.45
		If KeyHit(6) Then blur# = 0.6
		If KeyHit(7) Then blur# = 0.75
		If KeyHit(8) Then blur# = 0.8
		If KeyHit(9) Then blur# = 0.9
		If KeyHit(10) Then blur# = 0.93
		If KeyHit(11) Then blur# = 0.96
	
		If KeyHit(17) Then SaveBuffer(BackBuffer(),"Screanshoot"+MilliSecs()+".bmp")
	
		RenderWorld
		UpdateWorld

		If KeyHit(19) Then r=1-r
		If r Then
			setblurcolor 255,0,0
		Else
		  setblurcolor 255,255,255
		EndIf
	


		UpdateBlur(blur) ; Update Blur


	
		update_FPS(5) :; Update Fps


		Text GraphicsWidth()/2,GraphicsHeight()/2,"Jan's Blurlib",1,1
		Text GraphicsWidth()/2,GraphicsHeight()/2+20,Name$(m-1),1,1
		Text 10,60,"FPS: " +Int(FPS#)
		Text 10,80,"Polygon: "+TrisRendered()
		Text 10,100,"Textures used: "+ActiveTextures ()
		Text 10,120,"VRAM used: "+(TotalVidMem()-AvailVidMem())/(1024.0^2)
		Text 20,140,"Use 1,2,...,9,0"
		Text 20,160,"For the Power of the effekt."
		
		

		Flip 0

	Until KeyHit(1)
	freeblur()
Goto start ; nobig Goto :lol: